import { createRoute } from "../../../modules/api-utils/createRoute";
import { unifiSites } from "../../../managers/unifiSites";
import { apiResponse } from "../../../modules/api-utils/apiResponse";
import { ContentfulStatusCode } from "hono/utils/http-status";
import { authMiddleware } from "../../middleware/authorization";

/* GET /v1/unifi/site/:id/devices */
export default createRoute(
  "get",
  ["/site/:id/devices"],
  async (c) => {
    const site = await unifiSites.fetch(c.req.param("id"));
    const devices = await unifiSites.getDevices(site.siteId);
    const response = apiResponse.successful(
      "UniFi Devices Fetched Successfully!",
      devices,
    );
    return c.json(response, response.status as ContentfulStatusCode);
  },
  authMiddleware({ permissions: ["unifi.access", "unifi.site.devices"] }),
);
